<?php

if (!interface_exists('IFilesys'))
	throw new Exception('IFilesys: FSLocal: no interface found.');

class FSLocal implements IFilesys {
	private $env;

	public function __construct(&$env) {
		$this->env = &$env;
	}

	public function init() {
	}

	public function getDrivers() {
	 try {
		$result = Array();
		if ($this->env['os'] == 'unix')
			$result[] = '';
		else
			$result[] = 'C:';
		return $result;
	 }
	 catch(Exception $e) {
   }
	}

	public function getDirs($path) {
	 $result=Array();
   $handle=@opendir($path);
   if (!$handle) {
	   throw new Exception($this->env['modules']['translationModule']->translate('open_excp'));  
   }
    while (false!==($dir = readdir($handle))) {
    if ($dir != "." && $dir != "..") {
      if (is_dir($path.$this->getSeparator().$dir)){
          $result[] = $dir;
        }
      }
    }
    closedir($handle);
		return $result;   

	}//end getDirs

	public function getFiles($path) {
		$result=Array();
	  $handle=@opendir($path);
	  if (!$handle) {
		  throw new Exception($this->env['modules']['translationModule']->translate('open_excp'));  
   }
    while (false!==($file = readdir($handle))) {
      if ($file != "." && $file != "..") {
        if (!is_dir($path.$this->getSeparator().$file)){
          $result[] = $file;
        }
      }
    }
    closedir($handle);
    clearstatcache();
		return $result;

	}//end getFiles

	public function getFileInfo($path) {
		$result = Array('createDate' => @filectime($path),'lastModDate' =>@filemtime($path),'lastAcsDate' =>@fileatime($path),'size' =>@filesize($path));
		return $result;
	}//end getFileInfo

	public function isDir($path) {
  	return @is_dir($path);
	}//end isDir

	public function ifFile($path) {
	   return @is_file($path);
	}//end ifFile

	public function getWorkingPath($path) {
		return $path;	  
	}//end getWorkingPath

	private function cpyf($path_dst, $path_real_src)
         { // BEGIN function cpyf
         	if (@file_exists($path_dst)) {
						//echo "\n".' --- overwrite file --- '.$path_dst;
					}
					$copy = @copy($path_real_src,$path_dst);
					if (!$copy) {
						throw new Exception($this->env['modules']['translationModule']->translate('copy_errFile'));  
					}
					unset($copy);
         } // END function cpyf

	public function cpy($path_dst, $path_real_src) {
		if (@is_dir($path_real_src)) {
			if (!is_dir($path_dst)) {
				$mkdir = $this->makeDir($path_dst);
				unset($mkdir);
			}
			else {
				//echo ' --- overwrite dir --- '.$path_dst;
			}
			$file = $this->getFiles($path_real_src);
			for ($i=0;$i<@sizeof($file);$i++) {
				$this->cpyf($path_dst.$this->getSeparator().$file[$i], $path_real_src.$this->getSeparator().$file[$i]);
			}
			$dir = $this->getDirs($path_real_src);
			for ($i=0;$i<@sizeof($dir);$i++) {
				$this->cpy($path_dst.$this->getSeparator().$dir[$i], $path_real_src.$this->getSeparator().$dir[$i]);
			}
			unset($i,$file,$dir);
		}
		
		if (@is_file($path_real_src)) {
			$this->cpyf($path_dst, $path_real_src);
		}
		
	}//end cpy

	public function move($path_dst, $path_real_src) {
		if (@is_dir($path_real_src)) {
			if (!is_dir($path_dst)) {
				$mkdir = $this->makeDir($path_dst);
				unset($mkdir);
			}
			$file = $this->getFiles($path_real_src);
			for ($i=0;$i<@sizeof($file);$i++) {
				$this->cpyf($path_dst.$this->getSeparator().$file[$i], $path_real_src.$this->getSeparator().$file[$i]);
				$this->del($path_real_src.$this->getSeparator().$file[$i]);
			}
			$dir = $this->getDirs($path_real_src);
			for ($i=0;$i<@sizeof($dir);$i++) {
				$this->cpy($path_dst.$this->getSeparator().$dir[$i], $path_real_src.$this->getSeparator().$dir[$i]);
			}
			unset($i,$file,$dir);
			$this->del($path_real_src);
			
		}
		if (@is_file($path_real_src)) {
			$move = @copy($path_real_src,$path_dst);
			if (!$move) {
				throw new Exception($this->env['modules']['translationModule']->translate('move_errCopy'));  
			}
			$this->del($path_real_src);
		}
	}//end move

	private function recdel($dirname,$only_empty=false) {
    if (!is_dir($dirname))
        return false;
    $dscan = array(realpath($dirname));
    $darr = array();
    while (!empty($dscan)) {
        $dcur = array_pop($dscan);
        $darr[] = $dcur;
        if ($d=opendir($dcur)) {
            while ($f=readdir($d)) {
                if ($f=='.' || $f=='..')
                    continue;
                $f=$dcur.$this->getSeparator().$f;
                if (is_dir($f))
                    $dscan[] = $f;
                else
                    unlink($f);
            }
            closedir($d);
        }
    }
    $i_until = ($only_empty)? 1 : 0;
    for ($i=count($darr)-1; $i>=$i_until; $i--) {
        if (!rmdir($darr[$i]))
		throw new Exception($this->env['modules']['translationModule']->translate('cnt_removeDir'));
    }
    return (($only_empty)? (count(scandir)<=2) : (!is_dir($dirname)));
    }//end recdel

	public function del($path) {
		if (@is_file($path)) {
			$unlink = @unlink($path);
			if (!$unlink) {
				throw new Exception($this->env['modules']['translationModule']->translate('del_errFile'));  
			}
		}
		if (@is_dir($path)) {
			$rmdir = $this->recdel($path);
			//mazani plneho adresare
			if (!$rmdir) {
				throw new Exception($this->env['modules']['translationModule']->translate('del_errDir'));  
			}
		}
	}//end del

	public function makeDir($path) {
			if (@is_dir($path)) {
				throw new Exception($this->env['modules']['translationModule']->translate('dir_exists'));
			}
			else {
				$mkdir = @mkdir($path, 0775);//!!!!!!!!!!opravneni!!!
				if (!$mkdir) {
					throw new Exception($this->env['modules']['translationModule']->translate('dir_errMake'));
				}
			}
	}//end makeDir

	public function getSeparator() {
		if ($this->env['os'] == 'unix')
			return '/';
		else
			return '\\';
	}//end getSeparator


	public function ftp() {
		// set up basic connection
$conn_id = ftp_connect($ftp_server);

// login with username and password
$login_result = ftp_login($conn_id, $ftp_user_name, $ftp_user_pass);

// check connection
if ((!$conn_id) || (!$login_result)) {
        echo "FTP connection has failed!";
        echo "Attempted to connect to $ftp_server for user $ftp_user_name";
        exit;
    } else {
        echo "Connected to $ftp_server, for user $ftp_user_name";
    }

// upload the file
$upload = ftp_put($conn_id, $destination_file, $source_file, FTP_BINARY);

// check upload status
if (!$upload) {
        echo "FTP upload has failed!";
    } else {
        echo "Uploaded $source_file to $ftp_server as $destination_file";
    }

// close the FTP stream
ftp_close($conn_id);
	
	}

}//end class
?>
