<?php

if (!interface_exists('IPackZip'))
	throw new Exception('IPackZip: PackZip: no interface found.');
	
class PackZip implements IPackZip {
	
	private $env;
	
	public function __construct(&$env){
		$this->env = &$env;
	}
	
	public function zipFiles($src_path, $selectedFiles, $archiveName) {
		if(!class_exists('ZipArchive'))
			throw new Exception($this->env['modules']['translationModule']->translate('zip_moduleNF'));
		
		$zip = new ZipArchive();
		$fileName = $archiveName . ".zip";
		if ($zip->open($fileName, ZIPARCHIVE::CREATE)!==TRUE) {
			throw new Exception($this->env['modules']['translationModule']->translate('zip_cntCreate'));
		}
		
		foreach($selectedFiles as $file){
			$src_file_path = $src_path . $file;
			$zip->addFile($src_file_path, $file);
		}
		
		$zip->close();
	}
	
	public function unZipFiles($zipFile, $dstDir){
		if(!class_exists('ZipArchive'))
			throw new Exception($this->env['modules']['translationModule']->translate('zip_moduleNF'));
		
		$zip = new ZipArchive;
		if ($zip->open($zipFile) === TRUE) {
			$zip->extractTo($dstDir);
			$zip->close();
		} else {
			throw new Exception($this->env['modules']['translationModule']->translate('cnt_cntOpen'));
		}
	}
}

?>